climap/urls.py
from django.urls import path, register_converter
from . import views, export, basic

class Extension:
    regex = '[a-z]{2,3}'

    def to_python(self, value):
        return str(value)

    to_url = to_python

register_converter(Extension, 'xxx')


app_name = 'climap'

urlpatterns = [
    path('main/', views.main, name='main'),
    path('pre/', views.pre, name='pre'),
    path('img.png', views.image, name='image'),
    path('pinpoint/', views.point, name='pinpoint'),
    path('scale/<int:Metric_id>.png', views.scale, name='scale'),
    path('metadata/<int:Metric_id>/', views.metadata, name='metadata'),
    path('zones/<int:div_id>', views.zones, name='zones'),
#    path('plot/<int:Metric_id>', views.chartplot, name='plot'),
#    path('plot/<int:Metric_id>/<xxx:extension>', views.chartplot, name='csv'),
    path('help/', views.help, name='help'),
    path('api/', views.api, name='api'),
    path('month.<xxx:extension>', views.month, name='month'),
    path('year.<xxx:extension>', views.year, name='year'),
    path('basic', basic.index, name='basic'),
    path('export.<xxx:extension>', basic.image, name='plt'),
    path('data/', export.data, name='data'),
    path('download/', export.index, name='download'),
    path('confidence/', views.conf, name='confidence'),
    path('feedback/', basic.feedback, name='feedback'),
    path('feedbacksubmit/', basic.feedbacksubmit, name='feedbacksubmit'),
    path('guide/', basic.guide, name='guide'),
    path('', views.newindex, name='index'),
]

climatedemo/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
# from histo.views import main
from django.views.generic import TemplateView

from django.contrib.staticfiles.storage import staticfiles_storage
from django.views.generic.base import RedirectView

urlpatterns = [
    path('admin/', admin.site.urls),
    # path('climap/', include('climap.urls')),
    path('stats/', include('stats.urls')),
    path('proj/', include('proj.urls')),
    path('favicon.ico',
        RedirectView.as_view( # the redirecting function
            url=staticfiles_storage.url('img/favicon.ico'), # converts the static directory + our favicon into a URL
        ),
        name="favicon" # name of our view
    ),
    path('', TemplateView.as_view(template_name='proj/main.html'), name='main'),
]

# if not settings.DOCKER:
#     urlpatterns.insert(0, path('climap/', include('climap.urls')))

proj/urls.py
from django.urls import path, register_converter
from django.views.generic import TemplateView
from . import views
from .export import image
from .netcdf import write_netcdf
from .maintenance import print_zd, del_zd, del_mrd, print_sp, del_sp, display_station_proj, print_param, del_param, listings

app_name = 'proj'

class Extension:
    regex = '[a-z]{2,3}'

    def to_python(self, value):
        return str(value)

    to_url = to_python

register_converter(Extension, 'xxx')

urlpatterns = [
    # static
    path('about', views.about, name='about'),
    path('help', views.help, name='help'),
    path('formula', views.formula, name='formula'),
    path('download', views.download, name='download'),
    path('faq', TemplateView.as_view(template_name='proj/faq.html'), name='faq'),

    path ('downparam/<pr>_<scen>_<zone>.csv', views.param_download, name='param_download'),
    path('downmetric/<met>_<scen>_<model>.csv', views.metric_download, name='metric_download'),
    path('downmetric/<met>_<scen>.csv', views.metric_download, name='metric_download'),
    path('downmetric/<metric>_<scen>_<model>.nc', write_netcdf, name='netcdf'),
    path('downzone/<met>_<scen>_<zone>.csv', views.zone_metric_download, name='zone_download'),

    # json / export
    path('<update>.json', views.jsoner, name='jsoner'),
    path('<period>.csv', views.csv_export, name='csv'),
    path('<period>.xls', views.xls_export, name='xls'),
    path('export.<xxx:extension>', image, name='plt'),

    # language toggle
    path('lang/<l>', views.lang, name='lang'),

    # main page
    path('simple', views.simple, name='simple'),
    path('', views.index, name='index'),

    # admin
    path('listings', listings, name='listings'),
    path('mod_zd', print_zd, name='print_zd'),
    path('mod_param', print_param, name='print_param'),
    path('mod_sp', print_sp, name='print_sp'),
    path('stations', display_station_proj, name='display_station'),
    path('del_zd/<mid>/<modname>/<scen>', del_zd, name='del_zd_scen'),
    path('del_zd/<mid>/<modname>', del_zd, name='del_zd'),
    path('del_param/<pid>/<modname>/<scen>', del_param, name='del_param_scen'),
    path('del_param/<pid>/<modname>', del_param, name='del_param'),
    path('del_mrd/<mid>/<modname>/<scen>', del_mrd, name='del_mrd_scen'),
    path('del_mrd/<mid>/<modname>', del_mrd, name='del_mrd'),
    path('del_sp/<modname>/<pid>/<sid>/<scen>', del_sp, name='del_sp_scen'),
    path('del_sp/<modname>/<pid>/<sid>/', del_sp, name='del_sp'),
    ]

climap/models.py
from django.contrib.gis.db import models
import numpy as np
from .load import run_yearlyvalueset, run_monthlyvalueset, scaleraster, run_polygons
from django.db import connection
from .rasterfuns import RMax, RMin
from math import floor, ceil
from django.db.models import Max, Min

class NamedModel(models.Model):
    name = models.CharField(max_length=100)

    def __str__(self):
        return self.name

    class Meta:
        ordering = ('name',)
        abstract = True


# class Attribution(NamedModel):
#     file = models.FileField(upload_to='attributions/', blank=True)
#     url = models.URLField(blank=True)

class Division(NamedModel):
    file = models.FileField(upload_to='tmp/', blank=True)
    zonename = models.CharField(max_length=20, blank=True, help_text='Column in the shapefile for the actual name of the zone.')

    def save(self, *args, **kwargs):
        super(Division, self).save(*args, **kwargs)
        if(self.file):
            self.zone_set.all().delete()
            run_polygons(self, self.zonename)
            self.file.delete()


class Zone(NamedModel):
    division = models.ForeignKey(Division, on_delete=models.CASCADE)
    mpoly = models.MultiPolygonField()
    iso_code = models.CharField(max_length=4, blank=True)


class ModelGroup(NamedModel):
    color = models.CharField(max_length=20, help_text='Line color in graphs.')

class ClimateModel(NamedModel):
    description = models.TextField(blank=True, max_length = 500)
    url = models.URLField(blank=True)
    color = models.CharField(max_length=20, help_text='Line color in graphs.')
    STYLE_CHOICES = ('solid', 'dashed', 'dotted', 'dashdot')
    style = models.CharField(choices=zip(STYLE_CHOICES, STYLE_CHOICES), max_length=max(map(len,STYLE_CHOICES)))
    yearmin = models.IntegerField()
    yearmax = models.IntegerField()
    group = models.ForeignKey(ModelGroup, null=True, on_delete=models.SET_NULL)


class Scenario(NamedModel):
    color = models.CharField(max_length=20, help_text='Line color in graphs.')


class Colormap(NamedModel):
    """Coloring schemes for producing png."""
    code = models.TextField(max_length=300, help_text="List of rows of the form '{}:R:G:B:A'. Each row represents "
                           "a value linearly spaced between vmax and vmin. The last row "
                           "should always be 'nv:0:0:0:0' to allow transparency. "
                           "See <a href='http://colorbrewer2.org'>Colorbrewer</a> for ideas.)")

    def code2colormap(self):
        nums = list(map(lambda x:x.split(','), self.code.split('\r\n')))
        rgb = ['red', 'green', 'blue']
        cmap = {}
        n = len(nums)
        for c in range(3):
            coco = []
            for x in range(n):
                val = int(nums[x][c + 1])/255
                coco.append((1-(x/(n-1)), val, val))
            coco.reverse()
            cmap[rgb[c]] = coco
        return cmap


class MetricCategory(NamedModel):
    public = models.BooleanField(default=False, blank=True)

    class Meta:
        verbose_name_plural = "Metric categories"

    def get_ordered_metrics(self):
        """For display in templates."""
        return self.metric_set.filter(caseof__isnull=True)


class Metric(NamedModel):
    class Meta:
        ordering = ('shortname', 'name')

    unit = models.CharField(max_length=20)
    shortname = models.CharField(max_length=20, help_text="For exporting files.")
    yearvmin = models.FloatField(default=0)
    yearvmax = models.FloatField(default=0)
    monthvmin = models.FloatField(default=0)
    monthvmax = models.FloatField(default=0)
    scaleraster = models.RasterField(null=True)
    description = models.TextField(blank=True)
    colormap = models.ForeignKey(Colormap, null=True, on_delete=models.SET_NULL)
    category = models.ForeignKey(MetricCategory, null=True, on_delete=models.CASCADE)
    has_month = models.BooleanField(default=True, blank=True)
    caseof = models.ForeignKey('self', null=True, on_delete=models.SET_NULL, blank=True)

    def get_min_max(self, period='year'):
        if period == 'year':
            yv = YearlyValue.objects.filter(value_set__metric_id=self.id)\
                .annotate(rmax=RMax('raster'), rmin=RMin('raster'))
            self.yearvmin = floor(yv.aggregate(Min('rmin'))['rmin__min'])
            self.yearvmax = ceil(yv.aggregate(Max('rmax'))['rmax__max'])
        else:
            mv = MonthlyValue.objects.filter(value_set__metric_id=self.id)\
                .annotate(rmax=RMax('raster'), rmin=RMin('raster'))
            self.monthvmin = floor(mv.aggregate(Min('rmin'))['rmin__min'])
            self.monthvmax = ceil(mv.aggregate(Max('rmax'))['rmax__max'])
        self.save()

    # def extract_minmax(self, minmax='max', period='year'):
    #     with connection.cursor() as cursor:
    #         cursor.execute('select {minmax}(res) from (select (st_summarystats(raster)).{minmax} as res '
    #                        'from climap_{period}lyvalue, climap_valueset where value_set_id = climap_valueset.id '
    #                        'and metric_id = %s) as foo;'.format(minmax=minmax, period=period), [self.id])
    #         return cursor.fetchone()[0]

    def color_code(self, relative=False, vmin=None, vmax=None, period='year'):
        if relative:
            code = self.colormap.code
            vals = [ str(int(i))+'%%' for i in np.linspace(100, 0, code.count('{')) ]
        else:
            if period == 'year':
                vmin = vmin or self.yearvmin
                vmax = vmax or self.yearvmax
            else:
                vmin = vmin or self.monthvmin
                vmax = vmax or self.monthvmax

            lines = self.colormap.code.split('\n')
            code = '\n'.join([lines[0].format('100%%')] + lines + [lines[-2].format('0%%')])
            vals = np.linspace(vmax, vmin, code.count('{'))
        return self.colormap.code.format(*vals)

    def save(self, *args, **kwargs):
        self.scaleraster = scaleraster(self.yearvmin, self.yearvmax)
        super(Metric, self).save(*args, **kwargs)


class ValueSet(models.Model):
    model = models.ForeignKey(ClimateModel, null=True, on_delete=models.CASCADE)
    scenario = models.ForeignKey(Scenario, null=True, on_delete=models.CASCADE)
    metric = models.ForeignKey(Metric, on_delete=models.CASCADE)
    year_file = models.FileField(upload_to='tmp/', blank=True)
    month_file = models.FileField(upload_to='tmp/', blank=True)
    var = models.CharField(max_length=20, blank=True,
                           help_text='Variable used in the file. If unsure, '
                                     'try "cdo showname filename.nc" in commande line.')

    def __str__(self):
        return '{} {}, {}'.format(self.model, self.scenario, self.metric)


class YearlyValue(models.Model):
    class Meta:
        indexes = [
            models.Index(fields=['value_set']),
            models.Index(fields=['year']),
        ]
    year = models.IntegerField()
    raster = models.RasterField()
    value_set = models.ForeignKey(ValueSet, on_delete=models.CASCADE)

    def __str__(self):
        return '{}, year {}'.format(self.value_set, self.year)

months = ( 'January', 'February', 'March', 'April', 'May', 'June', 'July',
           'August', 'September', 'October', 'November', 'December' )
shortmonths = [ m[:3] for m in months ]

class MonthlyValue(models.Model):
    class Meta:
        indexes = [
            models.Index(fields=['value_set']),
            models.Index(fields=['year']),
            models.Index(fields=['month']),
        ]

    year = models.IntegerField()
    month = models.IntegerField()
    raster  = models.RasterField()
    value_set = models.ForeignKey(ValueSet, on_delete=models.CASCADE)

    def strmonth(self):
        return months[self.month]

    def __str__(self):
        return '{}, {} {}'.format(self.value_set, months[self.month], self.year)


class FeedBack(models.Model):
    date = models.DateTimeField(auto_now=True)
    #ip = models.GenericIPAddressField()
    usage = models.TextField(blank=True)
    missing = models.TextField(blank=True)
    download = models.TextField(blank=True)
    interface = models.TextField(blank=True)
    suggest = models.TextField(blank=True)
    def __str__(self):
        return 'Feedback on {}'.format(self.date)

climap/templates/climap/basic.html
{% extends 'base.html' %}

{% block content %}
<div class="smallpage">
    <h3>Simple form version</h3>
    <form action="{% url 'climap:basic' %}#results" method="post">
        {% csrf_token %}
        <ul class="djangoform">{{ form }}</ul>

        <input type="submit" value="Submit"/>
        <div class="helptext">Depending on the parameters, the request may take several seconds or minutes to display.</div>
    </form>

    {% if svg or png %}
        <h3 id="results">Results</h3>
    {% endif %}

    {% if svg %}
        {{ svg|safe }}
    {% endif %}

    {% if png %}
        <img src="{{ png }}">
    <div class="helptext">Right-click on images to save.</div>
    {% endif %}
</div>
{% endblock %}

climap/templates/climap/download.html
{% extends 'base.html' %}

{% block content %}
<div class="smallpage">
    <h3>Download</h3>
    <form action="{% url 'climap:data' %}" method="post">
        {% csrf_token %}
        <ul class="djangoform">{{ form }}</ul>
        <input type="submit" value="Submit"/>
    </form>
    {% if error %}
    <p class="helptext" style="color:red">{{ error }}</p>
    {% endif %}

</div>
{% endblock %}

climap/templates/climap/feedback.html
{% extends 'base.html' %}

{% block content %}
<div class="smallpage">
    <h2>Formulaire de retour</h2><h3>(version française)</h3>
    <form action="{% url 'climap:feedbacksubmit' %}" method="post">
        {% csrf_token %}
        <ul class="djangoform">
            <li>Quels paramètres avez-vous utilisés lors de votre utilisation ?
                <br>{{ f.usage }}</li>
            <li>Y a-t-il des paramètres (métriques, analyses) qui vous ont manqué ?
                <br>{{ f.missing }}</li>
            <li>Avez-vous téléchargé des données ? Si oui, sous quel format ?<br>{{ f.download }}</li>
            <li>Avez-vous eu des difficultés à manipuler l'interface du service ?<br>{{ f.interface }}</li>
            <li>Autres suggestions :<br>{{ f.suggest }}</li>
        </ul>

        <input type="submit" value="Soumettre">
    </form>

</div>
{% endblock %}

climap/templates/climap/guide.html
{% extends 'base.html' %}

{% block content %}
{% load static %}
<div class="smallpage">
    <h2>Advanced tool guide</h2>
    <p>This page describes the main menu of the advanced version of the climate data demonstrator.</p>

    <dl>
        <dt><i>parameter</i></dt>
        <dd>Chose one parameter to study. See <a href="{% url 'climap:help' %}">their description</a>.</dd>

        <dt><i>models</i></dt>
        <dd>List of models that will be averaged in the calculations. By default, all models are selected. This is also
            where you chose whether to compare scenarii, models, or model groups. In the first case,
            time charts will render the 3 scenarii, each with error bars (i.e. model standard deviation).
            In the second, each model will render
            separately, according to chosen scenario (next panel). The third case is similar, but aggregates similar models
            by average for a clearer view. See also <a
                    href="{% url 'climap:help' %}#models">model
                descriptions</a> and <a
                    href="{% url 'climap:help' %}#groups">model group
                description</a>.
            <table style="border:1px solid black;text-align:center;margin:10px;">
                <tr><td>Scenario display</td><td>Models display</td></tr>
                <tr>
                    <td><img width="100%" src="{% static 'img/g-scenarii.png' %}"></td>
                    <td><img width="100%" src="{% static 'img/g-models.png' %}"></td>
                </tr>
                <tr><td>Group display</td>
                <tr>
                    <td><img width="100%" src="{% static 'img/g-groups.png' %}"></td>
                </tr>
            </table>
        </dd>
        <dt><i>scenario</i></dt>
        <dd>The demonstrator includes three different scenarii describing possible climate futures
            depending
            on how much greenhouse gases are emitted in the years to come.
        </dd>
        <dt><i>zone</i></dt>
        <dd><p>This panel defines the zone of study. Time chart values are calculated by averaging pixels (or 'cells')
            included in the given zone. You may chose another zone of interest :</p>
            <ul>
                <li>clicking on <b>point</b>, then on the map, will limit the zone of study to a single pixel.</li>
                <li>clicking on <b>zone</b> will allow to chose another zone by clicking again on the map. Available zones are
                    countries by default, see "map settings > zones" below for more possibilities (e.g. country regions).
                </li>
                <li>chosing <b>custom zone</b> will allow you to draw a polygon on the map.</li>
            </ul>
        </dd>
        <dt><i>period</i></dt>
        <dd><p>This panel allows you to set time values.</p>
            <ul>
                <li>Chose a specific <b>month</b> or the whole year.</li>
                <li>The <b>year(s)</b> of study may concern on a specific year ("2005") or span a longer period
                    ("2050-2080"). In the latter case, you may chose the method to aggregate data between years.
                    <br>Note that aggregating by "sum" is only relevant for extensive parameters like "total rainfall"
                    or "number of days ..." .
                    Summing temperatures does not make sense.
                    <br>The models have value from 1950 to 2099. Intervals out of these bounds will be clamped or yield
                    no result.
                </li>
            </ul>
            <p>For instance, setting <i>"June 2050-2060, aggregate by max"</i> will return the maximum value of the
                parameter for
                all June months between 2050 and 2060.</p>
            <ul>
                <li>Finally, the <b>data</b> parameter allows to change between displaying values directly ("raw data"), or to
                    compare with a reference period. The latter is 1950-1980 by default and may be changed. Two
                    comparisons are possible :
                    <ul>
                        <li><b>absolute difference</b> is a simple difference, i.e. <i>future-past</i> where
                            <i>future</i> is
                            the studied value and <i>past</i> the reference value ;
                        </li>
                        <li><b>relative difference</b> applies the formula <i>100*(future-past)/past</i>. Note that this
                            metric should only be relevant for precipitation parameters like "total rainfall" and might
                            render
                            strange results when <i>past</i> approaches (or reaches) zero.
                        </li>
                    </ul>
                </li>
            </ul>
            <table style="border:1px solid black;text-align:center;margin:10px;">
                <tr>
                    <td>Raw month-by-month data</td>
                    <td>Month-by-month difference</td>
                </tr>
                <tr>
                    <td><img width="100%" src="{% static 'img/g-models.png' %}"></td>
                    <td><img width="100%" src="{% static 'img/g-diff.png' %}"></td>
                </tr>
            </table>
            <ul>
                <li>In case of comparison, it is possible to ask for a <b>confidence</b> region. This grays out pixels on the
                    map where
                    3/4 of <i>all</i> models (not only those selected) agree on difference sign.</li>
            </ul>
        </dd>
        </dd>
        <dt><i>map settings</i></dt>
        <dd><ul>
            <li>By default pixels are displayed <b>around selected zone</b>. You can chose to display the <b>'exact'
                zone</b>, i.e. exactly pixels that are going to be averaged in calculations,
                or on the contrary <b>as large as available</b>. Obviously, the latter may take more
                time to display.
            </li>
            <table style="border:1px solid black;text-align:center;margin:10px;">
                <tr>
                    <td>'Exact' zone</td>
                    <td>Near zone</td>
                    <td>As large as available</td>
                </tr>
                <tr>
                    <td><img width="100%" src="{% static 'img/area-exact.png' %}"></td>
                    <td><img width="100%" src="{% static 'img/area-near.png' %}"></td>
                    <td><img width="100%" src="{% static 'img/area-all.png' %}"></td>
                </tr>
            </table>
            <li>By default the <b>scale</b>, i.e. min and max bounds, is <b>relative</b> to the zone and time period.
                The next setting allows to extend these bounds to <b>absolute</b> values calculated over all time period and maximum area.
                This may be useful to compare several results, but on the other hand values are less readable.
                This is especially true for pluviometry, where large variations may be observed between African zones.
            <br>Bounds can also be set <b>manually</b>. Out-of-bounds values are not displayed in this case. Be careful to switch back to 'relative'
                when changing parameter or from/to comparisons.</li>
            <table style="border:1px solid black;text-align:center;margin:10px;">
                <tr><td colspan="3">Example : yearly pluviometry in Senegal, using the same values.</td></tr>
                <tr>
                    <td>Relative (auto) scale : 85-1552mm</td>
                    <td>Absolute scale : 0-13612mm</td>
                    <td>Scale manually set to 0-1000mm ; note that out-of-bounds values are discarded.</td>
                </tr>
                <tr>
                    <td><img width="100%" src="{% static 'img/scale-rel.png' %}"></td>
                    <td><img width="100%" src="{% static 'img/scale-all.png' %}"></td>
                    <td><img width="100%" src="{% static 'img/scale-man.png' %}"></td>
                </tr>
            </table>
            <li>The <b>zone</b> setting changes selectable zones, from regions to continent.</li>
            <li>The <b>background</b> map can be removed or set to a variety of map or satellite displays.</li>
            <li>Finally, the <b>opacity</b> cursor sets transparency of the data image. This may be useful especially
            when defining a custom zone with the help of a background.</li>

        </ul></dd>
        <dt><i>update</i></dt>
        <dd>For performance reasons, the map and charts are not updated every time a modification is done. You have
        to manually ask to update the results. Some calculations may take time, so it is possible to select which part
        are to be calculated again.</dd>
        <dt><i>export</i></dt>
        <dd>Finally, you may export the map and charts into several formats. As for update, it is possible to select
        which part is to be exported. Graphics are then calculated again with the matplotlib library and may slightly
        differ from the page visuals.
            <br>Supported formats are png, svg, pdf and eps. Note that eps does not support transparency, so scenario error bars
        will be dropped in this case.
        <br>It is also possible to download the csv files of time charts.</bt></dd>
    </dl>

</div>
{% endblock %}

climap/templates/climap/help.html
{% extends 'base.html' %}

{% block content %}
<div class="smallpage">
    <h2>Parameter list</h2>
    There are currently {{ metrics|length }} parameters in the database.
                     {% for c in catmetric %}
    <dl class="description">
                <h3>{{ c.name }}</h3>
                {% for m in c.metric_set.all %}

        <dt>{{ m.name }}</dt>
        <dd>{{ m.description }}</dd>
        {% endfor %}
    </dl>
        {% endfor %}
    <h2 id="models">Model list</h2>
    <p>Not all combinations parameter/scenario/model are available. Many models miss one entire scenario,
        and some miss specific metrics.</p>
    <dl>
        {% for m in models %}
        <dt style="color:{{ m.color }}">{{ m.name }}</dt>
        <dd>{{ m.description|escape|linebreaks }}
        {% if m.url %}<a class="exturl helptext" href="{{ m.url }}">{{ m.url }}</a>{% endif %}
            <br>Value sets : {{ m.vs }} on {{ m.scen }} scenari{% if m.scen > 1 %}i{% else %}o{% endif %}.</dd>
        {% endfor %}
    </dl>
    <h2 id="groups">Model groups</h2>
    <p>For a more compact view, climate models may be grouped into categories of similarities. The group
        collection presented here is borrowed from
        <a href="https://doi.org/10.1007/s00382-016-3236-y">[Monerie, PA., Sanchez-Gomez, E. & Boé, J. Clim Dyn (2017) 48: 2751]</a>, p.2753,
        with the same color code.
    </p>
    <dl>
        {% for g in groups %}
        <dt style="color:{{ g.color }}">{{ g.name }}</dt>
        <dd>Models : {{ g.climatemodel_set.all | join:', ' }}
        </dd>
        {% endfor %}
    </dl>
    <h2 id="scenarii">Scenarii</h2>
    <p>Representative Concentration Pathways (rcp) are greenhouse gas concentration trajectories adopted by
        the <a href="www.ipcc.ch">IPCC</a> in 2014. They describe possible climate futures, all of which are
        considered possible depending on how much greenhouse gases are emitted in the years to come.
        RCP2.6, RCP4.5, and RCP8.5 are named after a possible range of radiative forcing values in the year 2100
        relative to pre-industrial values (+2.6, +4.5, and +8.5 W/m2, respectively)</p>
</div>
{% endblock %}

climap/templates/climap/main.html
{% extends 'base.html' %}

{% block content %}
{% load static %}
<div class="smallpage">
    <p>This climate service aims at providing intelligible climate projection data in Africa through maps and time
        charts.
        It features several parameters based on temperature and rainfall, scaled on monthly and yearly time periods.
    </p>

    <p>Initial data is <a href="https://esgf-node.llnl.gov/projects/esgf-llnl/">Coupled Model Intercomparison Project
        Phase 5 (CMIP5)</a> global climate models. The version presented here has been
        <a href="https://doi.org/10.5194/esd-9-313-2018">bias-corrected for Africa using CDF-t method</a> as part of the
        <a href="https://www.amma2050.org/">AMMA 2050 project</a>, then re-scaled by month and year. Yield results have
        been obtained by <a href="http://sarra-h.teledetection.fr/SARRAH_Home.html">SARRA-H Ocelet</a>.</p>
    <p>The demonstrator comes in several versions :
    <dl>
        <dt><a href="{% url 'climap:index' %}">advanced</a></dt>
        <dd>Dynamic map version. Requires Firefox or Chrome. First a first visit, you may want to look at
            <a href="{% url 'climap:guide' %}">the guide</a>.</dd>
        <dt><a href="{% url 'climap:basic' %}">simple</a></dt>
        <dd>Static form only. Suitable for any browser.</dd>
        <dt><a href="{% url 'climap:download' %}">download</a></dt>
        <dd>Direct data download without visualisation.</dd>
    </dl>
    </p>


    <p>Ce travail a bénéficié d'une aide du Ministère de la Transition Ecologique et Solidaire au titre de la Convention relative à l’attribution d’un appui financier au bénéfice des services climatiques.</p>
    <p><i>This work was supported by a grant from the French Ministry for an Ecological and Solidary Transition as part of the Convention on financial support for climate services. </i></p>

    <table>
        <tr>
            <td><a href="http://cnrs.fr"><img width=120 src="{% static 'img/logo-cnrs.png' %}"></a></td>
            <td><a href="https://convention-services-climatiques.lsce.ipsl.fr/"><img width=120 src="{% static 'img/logo_cosc.png' %}"></a></td>
            <td><a href="http://cse.ipsl.fr"><img width=120 src="{% static 'img/logo_cse2.png' %}"></a></td>
            <td><a href="https://www.ecologique-solidaire.gouv.fr/"><img width=120 src="{% static 'img/logo_mtes.png' %}"></a></td>
            <td><a href="http://ird.fr"><img width=120 src="{% static 'img/logo_ird.png' %}"></a></td>
            <td><a href="http://www.espace-dev.fr/"><img width=120 src="{% static 'img/logo-espace-dev.jpg' %}"></a></td>
            <td><a href="http://afd.fr"><img width=120 src="{% static 'img/logo_afd.png' %}"></a></td>
            <td><a href="http://amma2050.org"><img width=120 src="{% static 'img/logo-AMMA_2015.jpg' %}"></a></td>
        </tr>
    </table>
</div>



{% endblock %}